/***************************************************************************
*   Copyright (C) 2010 by
*    Kai Lindholm <megantti@gmail.com>
*   
*   This program is free software; you can redistribute it and/or modify
*   it under the terms of the GNU General Public License as published by
*   the Free Software Foundation; either version 2 of the License, or
*   (at your option) any later version.
* 
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*   
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the
*   Free Software Foundation, Inc.,
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
****************************************************************************/

#ifndef _SPELL_EMITTER_H
#define _SPELL_EMITTER_H

#include "particle.h"

class spell_particle : public particle {
	public:
		spell_particle(double life, sf::Color col, sf::Vector2f pos, 
				sf::Vector2f vel = sf::Vector2f(), sf::Vector2f accel = sf::Vector2f()) : 
			particle(life, col, pos, vel, accel)
		{}
		
	protected:
		virtual void Render(sf::RenderTarget & target) const;
};

class spell_emitter : public particle_emitter {
	public: 
		spell_emitter(particle_engine &e, sf::Vector2f _pos) : 
			particle_emitter(e, 200.0f), pos(_pos) { }
	protected:
		sf::Vector2f pos;

		virtual particle* create();
};


#endif
